commit 6170941c1f3c46a17184e52eec710cbc375324bd
Author: Julian Binder <jabinder@andrew.cmu.edu>
Date:   Fri Nov 30 00:22:54 2012 -0500

    fixed !ENABLE on the stepper driver

diff --git a/scoutfly/scoutfly_rev3.brd b/scoutfly/scoutfly_rev3.brd
index edd3c77..47b16be 100755
--- a/scoutfly/scoutfly_rev3.brd
+++ b/scoutfly/scoutfly_rev3.brd
@@ -3302,6 +3302,12 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="15.494" y1="76.708" x2="14.351" y2="75.565" width="1.016" layer="1"/>
 <wire x1="41.783" y1="63.234" x2="40.652" y2="63.234" width="0.4064" layer="1"/>
 <wire x1="40.652" y1="63.234" x2="38.1" y2="65.786" width="0.4064" layer="1"/>
+<contactref element="IC1" pad="15"/>
+<wire x1="111.0742" y1="69.088" x2="112.395" y2="69.088" width="0.2032" layer="1"/>
+<wire x1="112.395" y1="69.088" x2="112.903" y2="68.58" width="0.2032" layer="1"/>
+<wire x1="112.903" y1="68.58" x2="112.903" y2="67.056" width="0.2032" layer="1"/>
+<wire x1="112.903" y1="67.056" x2="112.395" y2="66.548" width="0.2032" layer="1"/>
+<wire x1="112.395" y1="66.548" x2="111.0742" y2="66.548" width="0.2032" layer="1"/>
 </signal>
 <signal name="!PWR_KILL">
 <contactref element="U$16" pad="GPIO127_TS_IRQ"/>
@@ -3903,8 +3909,6 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="19.304" y1="85.344" x2="21.218" y2="85.344" width="0.4064" layer="1"/>
 <wire x1="19.05" y1="85.598" x2="19.304" y2="85.344" width="0.4064" layer="1"/>
 <wire x1="19.05" y1="86.487" x2="19.05" y2="85.598" width="0.4064" layer="1"/>
-<wire x1="15.113" y1="86.487" x2="19.05" y2="86.487" width="0.4064" layer="16"/>
-<wire x1="14.859" y1="86.233" x2="15.113" y2="86.487" width="0.4064" layer="16"/>
 <via x="19.05" y="86.487" extent="1-16" drill="0.381"/>
 <wire x1="21.218" y1="85.344" x2="28.067" y2="85.344" width="1.016" layer="1"/>
 <wire x1="28.067" y1="85.344" x2="29.21" y2="84.201" width="1.016" layer="1"/>
@@ -5238,7 +5242,6 @@ Please make sure your boards conform to these design rules.</description>
 <contactref element="IC1" pad="14"/>
 <contactref element="C79" pad="1"/>
 <contactref element="IC1" pad="3"/>
-<contactref element="IC1" pad="15"/>
 <contactref element="IC1" pad="24"/>
 <contactref element="IC1" pad="22"/>
 <contactref element="C31" pad="1"/>
@@ -5379,9 +5382,6 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="107.315" y1="68.033" x2="108.751" y2="68.033" width="0.254" layer="16"/>
 <wire x1="108.751" y1="68.033" x2="108.966" y2="67.818" width="0.254" layer="16"/>
 <wire x1="108.966" y1="67.818" x2="111.0742" y2="67.818" width="0.254" layer="1"/>
-<wire x1="109.22" y1="69.088" x2="111.0742" y2="69.088" width="0.254" layer="1"/>
-<wire x1="108.966" y1="68.834" x2="109.22" y2="69.088" width="0.254" layer="1"/>
-<wire x1="108.966" y1="67.818" x2="108.966" y2="68.834" width="0.254" layer="1"/>
 <wire x1="111.0742" y1="77.978" x2="112.522" y2="77.978" width="0.254" layer="1"/>
 <wire x1="112.522" y1="77.978" x2="112.649" y2="78.105" width="0.254" layer="1"/>
 <wire x1="112.649" y1="78.105" x2="112.649" y2="80.391" width="0.254" layer="1"/>
diff --git a/scoutfly/scoutfly_rev3.sch b/scoutfly/scoutfly_rev3.sch
index c6ae180..b921be7 100755
--- a/scoutfly/scoutfly_rev3.sch
+++ b/scoutfly/scoutfly_rev3.sch
@@ -19782,7 +19782,7 @@ Source: 3967.pdf</description>
 <instance part="GND76" gate="1" x="-271.78" y="-127"/>
 <instance part="P+4" gate="VCC" x="-264.16" y="-96.52" rot="MR0"/>
 <instance part="GND77" gate="1" x="-264.16" y="-111.76"/>
-<instance part="GND80" gate="1" x="-358.14" y="-91.44"/>
+<instance part="GND80" gate="1" x="-358.14" y="-104.14"/>
 <instance part="GND82" gate="1" x="228.6" y="-111.76" rot="MR0"/>
 <instance part="R21" gate="G$1" x="-342.9" y="-111.76" rot="R270"/>
 <instance part="R47" gate="G$1" x="-342.9" y="-124.46" rot="R270"/>
@@ -20384,6 +20384,11 @@ Source: 3967.pdf</description>
 <segment>
 <pinref part="R70" gate="G$1" pin="2"/>
 <pinref part="GND80" gate="1" pin="GND"/>
+<wire x1="-358.14" y1="-101.6" x2="-358.14" y2="-99.06" width="0.1524" layer="91"/>
+<pinref part="IC1" gate="G$1" pin="!ENABLE"/>
+<wire x1="-358.14" y1="-99.06" x2="-358.14" y2="-88.9" width="0.1524" layer="91"/>
+<wire x1="-325.12" y1="-99.06" x2="-358.14" y2="-99.06" width="0.1524" layer="91"/>
+<junction x="-358.14" y="-99.06"/>
 </segment>
 <segment>
 <wire x1="226.06" y1="-127" x2="218.44" y2="-127" width="0.1524" layer="91"/>
@@ -22057,16 +22062,13 @@ Source: 3967.pdf</description>
 <wire x1="-325.12" y1="-63.5" x2="-325.12" y2="-71.12" width="0.1524" layer="91"/>
 <wire x1="-325.12" y1="-96.52" x2="-342.9" y2="-96.52" width="0.1524" layer="91"/>
 <wire x1="-342.9" y1="-96.52" x2="-342.9" y2="-81.28" width="0.1524" layer="91"/>
-<wire x1="-325.12" y1="-99.06" x2="-342.9" y2="-99.06" width="0.1524" layer="91"/>
-<wire x1="-342.9" y1="-99.06" x2="-342.9" y2="-96.52" width="0.1524" layer="91"/>
 <wire x1="-325.12" y1="-104.14" x2="-342.9" y2="-104.14" width="0.1524" layer="91"/>
-<wire x1="-342.9" y1="-104.14" x2="-342.9" y2="-99.06" width="0.1524" layer="91"/>
+<wire x1="-342.9" y1="-104.14" x2="-342.9" y2="-96.52" width="0.1524" layer="91"/>
 <wire x1="-325.12" y1="-81.28" x2="-342.9" y2="-81.28" width="0.1524" layer="91"/>
 <wire x1="-342.9" y1="-81.28" x2="-342.9" y2="-63.5" width="0.1524" layer="91"/>
 <junction x="-358.14" y="-63.5"/>
 <junction x="-350.52" y="-63.5"/>
 <junction x="-342.9" y="-96.52"/>
-<junction x="-342.9" y="-99.06"/>
 <junction x="-342.9" y="-81.28"/>
 <junction x="-342.9" y="-63.5"/>
 <pinref part="R69" gate="G$1" pin="1"/>
@@ -22074,7 +22076,6 @@ Source: 3967.pdf</description>
 <pinref part="IC1" gate="G$1" pin="VCC"/>
 <pinref part="C79" gate="G$1" pin="1"/>
 <pinref part="IC1" gate="G$1" pin="!SLEEP"/>
-<pinref part="IC1" gate="G$1" pin="!ENABLE"/>
 <pinref part="IC1" gate="G$1" pin="PFD"/>
 <pinref part="IC1" gate="G$1" pin="!RESET"/>
 </segment>