commit 6dddacca09496695a08f08531a3d31a466a511c0
Author: Julian Binder <jabinder@andrew.cmu.edu>
Date:   Sat Dec 15 15:47:41 2012 -0500

    fixed library errors. also finished battery board

diff --git a/batboard/batboard.sch b/batboard/batboard.sch
old mode 100644
new mode 100755
index b014fdf..ba44bde
--- a/batboard/batboard.sch
+++ b/batboard/batboard.sch
@@ -1,6 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <!DOCTYPE eagle SYSTEM "eagle.dtd">
-<eagle version="6.3">
+<eagle version="6.2">
 <drawing>
 <settings>
 <setting alwaysvectorfont="no"/>
@@ -8,24 +8,24 @@
 </settings>
 <grid distance="0.1" unitdist="inch" unit="inch" style="lines" multiple="1" display="no" altdistance="0.01" altunitdist="inch" altunit="inch"/>
 <layers>
-<layer number="1" name="Top" color="4" fill="1" visible="no" active="no"/>
-<layer number="2" name="Route2" color="1" fill="3" visible="no" active="no"/>
-<layer number="3" name="Route3" color="4" fill="3" visible="no" active="no"/>
-<layer number="14" name="Route14" color="1" fill="6" visible="no" active="no"/>
-<layer number="15" name="Route15" color="4" fill="6" visible="no" active="no"/>
-<layer number="16" name="Bottom" color="1" fill="1" visible="no" active="no"/>
-<layer number="17" name="Pads" color="2" fill="1" visible="no" active="no"/>
-<layer number="18" name="Vias" color="2" fill="1" visible="no" active="no"/>
-<layer number="19" name="Unrouted" color="6" fill="1" visible="no" active="no"/>
-<layer number="20" name="Dimension" color="15" fill="1" visible="no" active="no"/>
-<layer number="21" name="tPlace" color="7" fill="1" visible="no" active="no"/>
-<layer number="22" name="bPlace" color="7" fill="1" visible="no" active="no"/>
-<layer number="23" name="tOrigins" color="15" fill="1" visible="no" active="no"/>
-<layer number="24" name="bOrigins" color="15" fill="1" visible="no" active="no"/>
-<layer number="25" name="tNames" color="7" fill="1" visible="no" active="no"/>
-<layer number="26" name="bNames" color="7" fill="1" visible="no" active="no"/>
-<layer number="27" name="tValues" color="7" fill="1" visible="no" active="no"/>
-<layer number="28" name="bValues" color="7" fill="1" visible="no" active="no"/>
+<layer number="1" name="Top" color="4" fill="1" visible="yes" active="no"/>
+<layer number="2" name="Route2" color="1" fill="3" visible="yes" active="no"/>
+<layer number="3" name="Route3" color="4" fill="3" visible="yes" active="no"/>
+<layer number="14" name="Route14" color="1" fill="6" visible="yes" active="no"/>
+<layer number="15" name="Route15" color="4" fill="6" visible="yes" active="no"/>
+<layer number="16" name="Bottom" color="1" fill="1" visible="yes" active="no"/>
+<layer number="17" name="Pads" color="2" fill="1" visible="yes" active="no"/>
+<layer number="18" name="Vias" color="2" fill="1" visible="yes" active="no"/>
+<layer number="19" name="Unrouted" color="6" fill="1" visible="yes" active="no"/>
+<layer number="20" name="Dimension" color="15" fill="1" visible="yes" active="no"/>
+<layer number="21" name="tPlace" color="7" fill="1" visible="yes" active="no"/>
+<layer number="22" name="bPlace" color="7" fill="1" visible="yes" active="no"/>
+<layer number="23" name="tOrigins" color="15" fill="1" visible="yes" active="no"/>
+<layer number="24" name="bOrigins" color="15" fill="1" visible="yes" active="no"/>
+<layer number="25" name="tNames" color="7" fill="1" visible="yes" active="no"/>
+<layer number="26" name="bNames" color="7" fill="1" visible="yes" active="no"/>
+<layer number="27" name="tValues" color="7" fill="1" visible="yes" active="no"/>
+<layer number="28" name="bValues" color="7" fill="1" visible="yes" active="no"/>
 <layer number="29" name="tStop" color="7" fill="3" visible="no" active="no"/>
 <layer number="30" name="bStop" color="7" fill="6" visible="no" active="no"/>
 <layer number="31" name="tCream" color="7" fill="4" visible="no" active="no"/>
@@ -34,8 +34,8 @@
 <layer number="34" name="bFinish" color="6" fill="6" visible="no" active="no"/>
 <layer number="35" name="tGlue" color="7" fill="4" visible="no" active="no"/>
 <layer number="36" name="bGlue" color="7" fill="5" visible="no" active="no"/>
-<layer number="37" name="tTest" color="7" fill="1" visible="no" active="no"/>
-<layer number="38" name="bTest" color="7" fill="1" visible="no" active="no"/>
+<layer number="37" name="tTest" color="7" fill="1" visible="yes" active="no"/>
+<layer number="38" name="bTest" color="7" fill="1" visible="yes" active="no"/>
 <layer number="39" name="tKeepout" color="4" fill="11" visible="no" active="no"/>
 <layer number="40" name="bKeepout" color="1" fill="11" visible="no" active="no"/>
 <layer number="41" name="tRestrict" color="4" fill="10" visible="no" active="no"/>
@@ -43,16 +43,16 @@
 <layer number="43" name="vRestrict" color="2" fill="10" visible="no" active="no"/>
 <layer number="44" name="Drills" color="7" fill="1" visible="no" active="no"/>
 <layer number="45" name="Holes" color="7" fill="1" visible="no" active="no"/>
-<layer number="46" name="Milling" color="3" fill="1" visible="no" active="no"/>
-<layer number="47" name="Measures" color="7" fill="1" visible="no" active="no"/>
-<layer number="48" name="Document" color="7" fill="1" visible="no" active="no"/>
-<layer number="49" name="Reference" color="7" fill="1" visible="no" active="no"/>
-<layer number="50" name="dxf" color="7" fill="1" visible="no" active="no"/>
-<layer number="51" name="tDocu" color="7" fill="1" visible="no" active="no"/>
-<layer number="52" name="bDocu" color="7" fill="1" visible="no" active="no"/>
-<layer number="53" name="tGND_GNDA" color="7" fill="9" visible="no" active="no"/>
-<layer number="54" name="bGND_GNDA" color="1" fill="9" visible="no" active="no"/>
-<layer number="56" name="wert" color="7" fill="1" visible="no" active="no"/>
+<layer number="46" name="Milling" color="3" fill="1" visible="yes" active="no"/>
+<layer number="47" name="Measures" color="7" fill="1" visible="yes" active="no"/>
+<layer number="48" name="Document" color="7" fill="1" visible="yes" active="no"/>
+<layer number="49" name="Reference" color="7" fill="1" visible="yes" active="no"/>
+<layer number="50" name="dxf" color="7" fill="1" visible="yes" active="no"/>
+<layer number="51" name="tDocu" color="7" fill="1" visible="yes" active="no"/>
+<layer number="52" name="bDocu" color="7" fill="1" visible="yes" active="no"/>
+<layer number="53" name="tGND_GNDA" color="7" fill="9" visible="yes" active="no"/>
+<layer number="54" name="bGND_GNDA" color="1" fill="9" visible="yes" active="no"/>
+<layer number="56" name="wert" color="7" fill="1" visible="yes" active="no"/>
 <layer number="91" name="Nets" color="2" fill="1" visible="yes" active="yes"/>
 <layer number="92" name="Busses" color="1" fill="1" visible="yes" active="yes"/>
 <layer number="93" name="Pins" color="2" fill="1" visible="no" active="yes"/>
@@ -180,7 +180,7 @@
 <wire x1="5.67" y1="-1.89" x2="5.67" y2="1.89" width="0.2" layer="21"/>
 <wire x1="5.67" y1="1.89" x2="-4.41" y2="1.89" width="0.2" layer="21"/>
 <text x="-2.90680625" y="-1.538796875" size="1.27" layer="21" rot="R90">1</text>
-<text x="6.801725" y="-1.8388375" size="0.8128" layer="21" rot="R90">&lt;Name</text>
+<text x="6.801725" y="-1.8388375" size="0.8128" layer="25" rot="R90">&gt;Name</text>
 </package>
 </packages>
 <symbols>
@@ -1894,7 +1894,7 @@ Standard 2-pin 0.1" header. Use with straight break away headers (SKU : PRT-0011
 </classes>
 <parts>
 <part name="U$1" library="jabinder" deviceset="BK-18650-PC4" device=""/>
-<part name="U2" library="jabinder" deviceset="LT3650" device=""/>
+<part name="U1" library="jabinder" deviceset="LT3650" device=""/>
 <part name="CHRG" library="jabinder" deviceset="C-GRID-71308" device=""/>
 <part name="BAT" library="jabinder" deviceset="C-GRID-71308" device=""/>
 <part name="GND1" library="supply1" deviceset="GND" device=""/>
@@ -1906,13 +1906,13 @@ Standard 2-pin 0.1" header. Use with straight break away headers (SKU : PRT-0011
 <part name="GND3" library="supply1" deviceset="GND" device=""/>
 <part name="C3" library="SparkFun-Capacitors" deviceset="CAP" device="0805" value="10uF"/>
 <part name="GND4" library="supply1" deviceset="GND" device=""/>
-<part name="R1" library="SparkFun-Passives" deviceset="RESISTOR" device="0805-RES" value="0.05"/>
+<part name="R1" library="SparkFun-Passives" deviceset="RESISTOR" device="2512" value="0.05"/>
 <part name="JP1" library="SparkFun-Connectors" deviceset="M02" device="PTH"/>
 <part name="GND5" library="supply1" deviceset="GND" device=""/>
 <part name="C4" library="SparkFun-Capacitors" deviceset="CAP" device="0805" value="0.68uF"/>
 <part name="D2" library="SparkFun-DiscreteSemi" deviceset="DIODE-SCHOTTKY" device="_"/>
 <part name="GND7" library="supply1" deviceset="GND" device=""/>
-<part name="U$2" library="jabinder" deviceset="UCC3911" device=""/>
+<part name="U2" library="jabinder" deviceset="UCC3911" device=""/>
 <part name="C5" library="SparkFun-Capacitors" deviceset="CAP" device="0805" value="330pF"/>
 <part name="C6" library="SparkFun-Capacitors" deviceset="CAP" device="0805" value="10uF"/>
 <part name="R2" library="SparkFun-Passives" deviceset="RESISTOR" device="0603-RES" value="220"/>
@@ -1938,23 +1938,20 @@ Standard 2-pin 0.1" header. Use with straight break away headers (SKU : PRT-0011
 <wire x1="-22.86" y1="-45.72" x2="-22.86" y2="-17.78" width="0.1524" layer="97"/>
 <text x="-51.054" y="-44.704" size="2.54" layer="97">Batt Header</text>
 <text x="-50.038" y="56.896" size="2.54" layer="97">CHRG Header</text>
-<text x="-2.54" y="53.34" size="1.778" layer="97">WSLPD-.05CT-ND For Current Sense Resistor</text>
+<text x="-2.54" y="53.34" size="1.778" layer="97">WSLG-.07CT-ND For Current Sense Resistor</text>
 <wire x1="-22.86" y1="60.96" x2="78.74" y2="60.96" width="0.1524" layer="97"/>
 <wire x1="78.74" y1="60.96" x2="78.74" y2="-5.08" width="0.1524" layer="97"/>
 <wire x1="78.74" y1="-5.08" x2="-22.86" y2="-5.08" width="0.1524" layer="97"/>
 <text x="22.86" y="0" size="2.54" layer="97">Charge Circuit</text>
-<text x="-10.16" y="55.88" size="2.54" layer="97">TODO: FIX CHARGE CURRENT TO 1435mA</text>
 <wire x1="-22.86" y1="-45.72" x2="-22.86" y2="-58.42" width="0.1524" layer="97"/>
 <wire x1="-22.86" y1="-58.42" x2="78.74" y2="-58.42" width="0.1524" layer="97"/>
 <wire x1="78.74" y1="-58.42" x2="78.74" y2="-5.08" width="0.1524" layer="97"/>
 <wire x1="-53.34" y1="-45.72" x2="-22.86" y2="-45.72" width="0.1524" layer="97"/>
 <text x="48.26" y="-50.8" size="2.54" layer="97">Protection Circuit</text>
-<text x="-20.32" y="-58.42" size="2.54" layer="97">STILL NEED TO ADD
-HIGH CURRENT HEAT SINK</text>
 </plain>
 <instances>
 <instance part="U$1" gate="G$1" x="-38.1" y="12.7"/>
-<instance part="U2" gate="G$1" x="20.32" y="35.56"/>
+<instance part="U1" gate="G$1" x="20.32" y="35.56"/>
 <instance part="CHRG" gate="G$1" x="-38.1" y="50.8"/>
 <instance part="BAT" gate="G$1" x="-38.1" y="-30.48"/>
 <instance part="GND1" gate="1" x="-27.94" y="-40.64"/>
@@ -1976,7 +1973,7 @@ HIGH CURRENT HEAT SINK</text>
 <attribute name="NAME" x="60.96" y="52.8574" size="1.778" layer="95" rot="R180"/>
 </instance>
 <instance part="GND7" gate="1" x="63.5" y="43.18"/>
-<instance part="U$2" gate="G$1" x="17.78" y="-30.48"/>
+<instance part="U2" gate="G$1" x="17.78" y="-30.48"/>
 <instance part="C5" gate="G$1" x="45.72" y="-17.78" rot="R90"/>
 <instance part="C6" gate="G$1" x="55.88" y="-12.7" rot="R180"/>
 <instance part="R2" gate="G$1" x="63.5" y="-10.16"/>
@@ -2008,7 +2005,7 @@ HIGH CURRENT HEAT SINK</text>
 <segment>
 <pinref part="D1" gate="G$1" pin="A"/>
 <wire x1="45.72" y1="33.02" x2="45.72" y2="30.48" width="0.1524" layer="91"/>
-<pinref part="U2" gate="G$1" pin="BAT"/>
+<pinref part="U1" gate="G$1" pin="BAT"/>
 <wire x1="45.72" y1="30.48" x2="35.56" y2="30.48" width="0.1524" layer="91"/>
 <pinref part="C3" gate="G$1" pin="1"/>
 <wire x1="45.72" y1="30.48" x2="55.88" y2="30.48" width="0.1524" layer="91"/>
@@ -2068,7 +2065,7 @@ HIGH CURRENT HEAT SINK</text>
 <pinref part="GND2" gate="1" pin="GND"/>
 </segment>
 <segment>
-<pinref part="U2" gate="G$1" pin="GND"/>
+<pinref part="U1" gate="G$1" pin="GND"/>
 <wire x1="0" y1="15.24" x2="0" y2="7.62" width="0.1524" layer="91"/>
 <wire x1="5.08" y1="15.24" x2="0" y2="15.24" width="0.1524" layer="91"/>
 <pinref part="GND3" gate="1" pin="GND"/>
@@ -2098,10 +2095,10 @@ HIGH CURRENT HEAT SINK</text>
 <pinref part="GND7" gate="1" pin="GND"/>
 </segment>
 <segment>
-<pinref part="U$2" gate="G$1" pin="GND2"/>
+<pinref part="U2" gate="G$1" pin="GND2"/>
 <wire x1="5.08" y1="-43.18" x2="0" y2="-43.18" width="0.1524" layer="91"/>
 <wire x1="0" y1="-43.18" x2="0" y2="-38.1" width="0.1524" layer="91"/>
-<pinref part="U$2" gate="G$1" pin="GND"/>
+<pinref part="U2" gate="G$1" pin="GND"/>
 <wire x1="0" y1="-38.1" x2="5.08" y2="-38.1" width="0.1524" layer="91"/>
 <wire x1="0" y1="-38.1" x2="-10.16" y2="-38.1" width="0.1524" layer="91"/>
 <junction x="0" y="-38.1"/>
@@ -2125,11 +2122,11 @@ HIGH CURRENT HEAT SINK</text>
 <label x="-48.26" y="40.64" size="1.778" layer="95" rot="R90"/>
 </segment>
 <segment>
-<pinref part="U2" gate="G$1" pin="!SHDN"/>
+<pinref part="U1" gate="G$1" pin="!SHDN"/>
 <wire x1="5.08" y1="35.56" x2="-2.54" y2="35.56" width="0.1524" layer="91"/>
-<pinref part="U2" gate="G$1" pin="VIN"/>
+<pinref part="U1" gate="G$1" pin="VIN"/>
 <wire x1="5.08" y1="45.72" x2="-2.54" y2="45.72" width="0.1524" layer="91"/>
-<pinref part="U2" gate="G$1" pin="CLP"/>
+<pinref part="U1" gate="G$1" pin="CLP"/>
 <wire x1="5.08" y1="40.64" x2="-2.54" y2="40.64" width="0.1524" layer="91"/>
 <wire x1="-2.54" y1="40.64" x2="-2.54" y2="45.72" width="0.1524" layer="91"/>
 <junction x="-2.54" y="45.72"/>
@@ -2146,7 +2143,7 @@ HIGH CURRENT HEAT SINK</text>
 <net name="N$6" class="0">
 <segment>
 <pinref part="C2" gate="G$1" pin="2"/>
-<pinref part="U2" gate="G$1" pin="SW"/>
+<pinref part="U1" gate="G$1" pin="SW"/>
 <wire x1="45.72" y1="48.26" x2="35.56" y2="48.26" width="0.1524" layer="91"/>
 <wire x1="35.56" y1="48.26" x2="35.56" y2="45.72" width="0.1524" layer="91"/>
 <pinref part="L1" gate="G$1" pin="2"/>
@@ -2160,7 +2157,7 @@ HIGH CURRENT HEAT SINK</text>
 </net>
 <net name="N$2" class="0">
 <segment>
-<pinref part="U2" gate="G$1" pin="BOOST"/>
+<pinref part="U1" gate="G$1" pin="BOOST"/>
 <pinref part="C2" gate="G$1" pin="1"/>
 <wire x1="35.56" y1="40.64" x2="45.72" y2="40.64" width="0.1524" layer="91"/>
 <pinref part="D1" gate="G$1" pin="C"/>
@@ -2170,7 +2167,7 @@ HIGH CURRENT HEAT SINK</text>
 </net>
 <net name="N$7" class="0">
 <segment>
-<pinref part="U2" gate="G$1" pin="SENSE"/>
+<pinref part="U1" gate="G$1" pin="SENSE"/>
 <pinref part="L1" gate="G$1" pin="1"/>
 <wire x1="50.8" y1="35.56" x2="55.88" y2="35.56" width="0.1524" layer="91"/>
 <wire x1="55.88" y1="35.56" x2="55.88" y2="40.64" width="0.1524" layer="91"/>
@@ -2182,7 +2179,7 @@ HIGH CURRENT HEAT SINK</text>
 </net>
 <net name="N$3" class="0">
 <segment>
-<pinref part="U2" gate="G$1" pin="NTC"/>
+<pinref part="U1" gate="G$1" pin="NTC"/>
 <pinref part="JP1" gate="G$1" pin="2"/>
 <wire x1="35.56" y1="25.4" x2="43.18" y2="25.4" width="0.1524" layer="91"/>
 <wire x1="43.18" y1="25.4" x2="43.18" y2="17.78" width="0.1524" layer="91"/>
@@ -2191,20 +2188,20 @@ HIGH CURRENT HEAT SINK</text>
 <net name="N$4" class="0">
 <segment>
 <pinref part="C4" gate="G$1" pin="2"/>
-<pinref part="U2" gate="G$1" pin="TIMER"/>
+<pinref part="U1" gate="G$1" pin="TIMER"/>
 <wire x1="2.54" y1="20.32" x2="5.08" y2="20.32" width="0.1524" layer="91"/>
 </segment>
 </net>
 <net name="N$9" class="0">
 <segment>
-<pinref part="U$2" gate="G$1" pin="CDLY"/>
+<pinref part="U2" gate="G$1" pin="CDLY"/>
 <pinref part="C5" gate="G$1" pin="1"/>
 <wire x1="35.56" y1="-17.78" x2="40.64" y2="-17.78" width="0.1524" layer="91"/>
 </segment>
 </net>
 <net name="N$10" class="0">
 <segment>
-<pinref part="U$2" gate="G$1" pin="B2"/>
+<pinref part="U2" gate="G$1" pin="B2"/>
 <wire x1="35.56" y1="-12.7" x2="48.26" y2="-12.7" width="0.1524" layer="91"/>
 <wire x1="48.26" y1="-12.7" x2="48.26" y2="-10.16" width="0.1524" layer="91"/>
 <pinref part="C6" gate="G$1" pin="2"/>
@@ -2221,10 +2218,10 @@ HIGH CURRENT HEAT SINK</text>
 <label x="-27.94" y="-5.08" size="1.778" layer="95" rot="R90"/>
 </segment>
 <segment>
-<pinref part="U$2" gate="G$1" pin="B0.1"/>
+<pinref part="U2" gate="G$1" pin="B0.1"/>
 <wire x1="35.56" y1="-43.18" x2="40.64" y2="-43.18" width="0.1524" layer="91"/>
 <wire x1="40.64" y1="-43.18" x2="40.64" y2="-38.1" width="0.1524" layer="91"/>
-<pinref part="U$2" gate="G$1" pin="B0.2"/>
+<pinref part="U2" gate="G$1" pin="B0.2"/>
 <wire x1="40.64" y1="-38.1" x2="35.56" y2="-38.1" width="0.1524" layer="91"/>
 <junction x="40.64" y="-38.1"/>
 <wire x1="55.88" y1="-17.78" x2="55.88" y2="-38.1" width="0.1524" layer="91"/>
@@ -2247,7 +2244,7 @@ HIGH CURRENT HEAT SINK</text>
 </net>
 <net name="N$13" class="0">
 <segment>
-<pinref part="U$2" gate="G$1" pin="B1"/>
+<pinref part="U2" gate="G$1" pin="B1"/>
 <wire x1="35.56" y1="-22.86" x2="58.42" y2="-22.86" width="0.1524" layer="91"/>
 <wire x1="58.42" y1="-22.86" x2="58.42" y2="-25.4" width="0.1524" layer="91"/>
 <pinref part="C7" gate="G$1" pin="2"/>
@@ -2257,20 +2254,32 @@ HIGH CURRENT HEAT SINK</text>
 </net>
 <net name="N$1" class="0">
 <segment>
-<pinref part="U$2" gate="G$1" pin="CE"/>
+<pinref part="U2" gate="G$1" pin="CE"/>
 <pinref part="JP2" gate="G$1" pin="2"/>
 <wire x1="35.56" y1="-48.26" x2="38.1" y2="-48.26" width="0.1524" layer="91"/>
 </segment>
 </net>
+<net name="HSINK" class="0">
+<segment>
+<pinref part="U2" gate="G$1" pin="SUBS1"/>
+<wire x1="5.08" y1="-27.94" x2="-2.54" y2="-27.94" width="0.1524" layer="91"/>
+</segment>
+<segment>
+<pinref part="U2" gate="G$1" pin="SUBS2"/>
+<wire x1="5.08" y1="-33.02" x2="-2.54" y2="-33.02" width="0.1524" layer="91"/>
+</segment>
+<segment>
+<pinref part="U2" gate="G$1" pin="SUBS4"/>
+<wire x1="35.56" y1="-27.94" x2="43.18" y2="-27.94" width="0.1524" layer="91"/>
+</segment>
+<segment>
+<pinref part="U2" gate="G$1" pin="SUBS3"/>
+<wire x1="35.56" y1="-33.02" x2="43.18" y2="-33.02" width="0.1524" layer="91"/>
+</segment>
+</net>
 </nets>
 </sheet>
 </sheets>
 </schematic>
 </drawing>
-<compatibility>
-<note version="6.3" minversion="6.2.2" severity="warning">
-Since Version 6.2.2 text objects can contain more than one line,
-which will not be processed correctly with this version.
-</note>
-</compatibility>
 </eagle>