commit 7f095440408d601f898e13795bfd0da713393a0d
Author: Priya <pdeo@Phlegethon.(none)>
Date:   Fri Nov 30 19:55:09 2012 -0500

    Sepearated refresh rate for scouts and for the simulator.

diff --git a/scout/libscout/src/behaviors/line_follow.cpp b/scout/libscout/src/behaviors/line_follow.cpp
index 0873ee1..9a17f90 100644
--- a/scout/libscout/src/behaviors/line_follow.cpp
+++ b/scout/libscout/src/behaviors/line_follow.cpp
@@ -38,8 +38,6 @@ void line_follow::follow_line()
     {
         double line_loc = linesensor->readline();
 
-        ROS_INFO("Line location: %lf.\n", line_loc);
-
         motor_l = min(max((int) (-MOTOR_BASE + SCALE * line_loc), -128), 127);
         motor_r = min(max((int) (-MOTOR_BASE - SCALE * line_loc), -128), 127);
 
diff --git a/scout/scoutsim/src/scout.cpp b/scout/scoutsim/src/scout.cpp
index 9d9502f..2d1adb2 100644
--- a/scout/scoutsim/src/scout.cpp
+++ b/scout/scoutsim/src/scout.cpp
@@ -410,19 +410,19 @@ namespace scoutsim
         float r_speed = (float (motor_fr_speed + motor_br_speed)) / 2;
 
         // Find linear and angular movement in m
-        float lin_dist = SCOUTSIM_REFRESH_RATE * (l_speed + r_speed) / 2;
-        float ang_dist = SCOUTSIM_REFRESH_RATE * (r_speed - l_speed);
+        float lin_dist = SIM_TIME_REFRESH_RATE * (l_speed + r_speed) / 2;
+        float ang_dist = SIM_TIME_REFRESH_RATE * (r_speed - l_speed);
 
         Vector2 old_pos = pos;
 
         // Update encoders
-        fl_ticks += (unsigned int) (motor_fl_speed * SCOUTSIM_REFRESH_RATE *
+        fl_ticks += (unsigned int) (motor_fl_speed * SIM_TIME_REFRESH_RATE *
                                     ENCODER_TICKS_PER_METER);
-        fr_ticks += (unsigned int) (motor_fr_speed * SCOUTSIM_REFRESH_RATE *
+        fr_ticks += (unsigned int) (motor_fr_speed * SIM_TIME_REFRESH_RATE *
                                     ENCODER_TICKS_PER_METER);
-        bl_ticks += (unsigned int) (motor_bl_speed * SCOUTSIM_REFRESH_RATE *
+        bl_ticks += (unsigned int) (motor_bl_speed * SIM_TIME_REFRESH_RATE *
                                     ENCODER_TICKS_PER_METER);
-        br_ticks += (unsigned int) (motor_br_speed * SCOUTSIM_REFRESH_RATE *
+        br_ticks += (unsigned int) (motor_br_speed * SIM_TIME_REFRESH_RATE *
                                     ENCODER_TICKS_PER_METER);
 
         orient = fmod((float) (orient + ang_dist), (float) (2.0 * PI));
diff --git a/scout/scoutsim/src/scout_constants.h b/scout/scoutsim/src/scout_constants.h
index c21b368..34c03a3 100644
--- a/scout/scoutsim/src/scout_constants.h
+++ b/scout/scoutsim/src/scout_constants.h
@@ -81,7 +81,8 @@ namespace scoutsim
     // Time it takes for the sonar to spin from position 0 to position 23
     const float SONAR_HALF_SPIN_TIME = 0.5;
 
-    const float SCOUTSIM_REFRESH_RATE = 0.05;   // s
+    const float REAL_TIME_REFRESH_RATE = 0.08;   // s
+    const float SIM_TIME_REFRESH_RATE = 0.05;   // s
 }
 
 #endif
diff --git a/scout/scoutsim/src/sim_frame.cpp b/scout/scoutsim/src/sim_frame.cpp
index 1b452c0..cc2fb92 100644
--- a/scout/scoutsim/src/sim_frame.cpp
+++ b/scout/scoutsim/src/sim_frame.cpp
@@ -68,7 +68,7 @@ namespace scoutsim
         srand(time(NULL));
 
         update_timer = new wxTimer(this);
-        update_timer->Start(SCOUTSIM_REFRESH_RATE * 1000);
+        update_timer->Start(REAL_TIME_REFRESH_RATE * 1000);
 
         Connect(update_timer->GetId(), wxEVT_TIMER,
                 wxTimerEventHandler(SimFrame::onUpdate), NULL, this);
@@ -316,7 +316,7 @@ namespace scoutsim
         SetSize(wxSize(path_bitmap.GetWidth(), path_bitmap.GetHeight()));
     }
 
-    // Runs every SCOUTSIM_REFRESH_RATE.
+    // Runs every REAL_TIME_REFRESH_RATE.
     void SimFrame::onUpdate(wxTimerEvent& evt)
     {
         ros::spinOnce();
@@ -402,13 +402,13 @@ namespace scoutsim
         }
         else if (wxGetKeyState(WXK_LEFT))
         {
-            teleop_l_speed = -TELEOP_PRECISE_SPEED * 2;
-            teleop_r_speed = TELEOP_PRECISE_SPEED * 2;
+            teleop_l_speed = -TELEOP_PRECISE_SPEED * 4;
+            teleop_r_speed = TELEOP_PRECISE_SPEED * 4;
         }
         else if (wxGetKeyState(WXK_RIGHT))
         {
-            teleop_l_speed = TELEOP_PRECISE_SPEED * 2;
-            teleop_r_speed = -TELEOP_PRECISE_SPEED * 2;
+            teleop_l_speed = TELEOP_PRECISE_SPEED * 4;
+            teleop_r_speed = -TELEOP_PRECISE_SPEED * 4;
         }
     }
 
@@ -437,11 +437,11 @@ namespace scoutsim
 
         if (wxGetKeyState(WXK_LEFT))
         {
-            teleop_fluid_omega -= TELEOP_FLUID_INC;
+            teleop_fluid_omega -= TELEOP_FLUID_INC * 2;
         }
         else if (wxGetKeyState(WXK_RIGHT))
         {
-            teleop_fluid_omega += TELEOP_FLUID_INC;
+            teleop_fluid_omega += TELEOP_FLUID_INC * 2;
         }
         else
         {
@@ -522,7 +522,7 @@ namespace scoutsim
 
         for (; it != end; ++it)
         {
-            it->second->update(SCOUTSIM_REFRESH_RATE,
+            it->second->update(SIM_TIME_REFRESH_RATE,
                                path_dc,sonar_dc,sonar_visual_on,
                                path_image, lines_image, walls_image,
                                path_dc.GetBackground().GetColour(),
@@ -532,7 +532,7 @@ namespace scoutsim
 
         for (unsigned int i=0; i<ghost_scouts.size(); ++i)
         {
-            ghost_scouts.at(i)->update(0.016, path_dc, sonar_dc,
+            ghost_scouts.at(i)->update(SIM_TIME_REFRESH_RATE, path_dc, sonar_dc,
                 path_dc.GetBackground().GetColour(), state);
         }
 
diff --git a/scout/scoutsim/src/sim_frame.h b/scout/scoutsim/src/sim_frame.h
index 991a4d5..54a0719 100644
--- a/scout/scoutsim/src/sim_frame.h
+++ b/scout/scoutsim/src/sim_frame.h
@@ -79,7 +79,7 @@
 #define ID_SONAR 10
 
 // Absolute speeds (-128 - 127)
-#define TELEOP_PRECISE_SPEED 62
+#define TELEOP_PRECISE_SPEED 50
 #define TELEOP_FLUID_MAX_SPEED 100
 #define TELEOP_FLUID_INC 8
 